CREATE OR REPLACE
PROCEDURE GERA_SOLICITA_CORTE_OL
  (P_CDFILIOPELOG     IN FILIAL.CDFILIAL%TYPE,
   P_CDFILLANC        IN FILIAL.CDFILIAL%TYPE,
   P_CDOPERLANC       IN OPERADOR.CDOPERADOR%TYPE,
   P_DTINICIAL        IN DATE,
   P_DTFINAL          IN DATE,
   P_DTINICIALAF      IN DATE,
   P_DTFINALAF        IN DATE,
   P_TIPOCONSULTA     IN VARCHAR2,
   P_COMPRADOR        IN OPERADOR.CDOPERADOR%TYPE,
   P_CDREGIAO         IN VARCHAR2,
   P_CDPRODINIC       IN PRODUTO.CDARVPROD%TYPE,
   P_CDPRODFIN        IN PRODUTO.CDARVPROD%TYPE,
   P_ROWSAFFECT       OUT VARCHAR2,
   P_PRXSOLICMP       IN VARCHAR2,
   P_NRLOGCORTEOL     IN VARCHAR2)
IS
   V_PRXSOLICMP   VARCHAR2(20);
   V_CDFILCENT    VARCHAR2(4);
   V_IDUTAPROVSOL CHAR(1);
   V_IDSOLIAPROV  CHAR(1);
   V_IDPERALTSAPR CHAR(1);

   W_S            CHAR(1) := 'S';
   W_N            CHAR(1) := 'N';

   V_CDFILCENTCMP  VARCHAR2(4);
   V_CONTAITEMCORT FLOAT := 0;
   V_QTSOLIPROD    FLOAT := 0;
   V_IDCORTEOLCONS VARCHAR2(1) := '';
   V_IDCORTE       VARCHAR2(1) := 'N';
   V_IDSEMCORTE    VARCHAR2(1) := 'N';
   V_CDMARCA       VARCHAR2(5);
   V_QTESTOSEGU    FLOAT;
   V_QTESTCALC     FLOAT;
   V_QTPROGENTAF   FLOAT;
   V_ITEMGERADO    VARCHAR2(1) := 'N';
   V_NRLOGITEMCORTEOL VARCHAR2(10) := '';
   V_NRLOGCORTEOLCONS VARCHAR2(10) := '';
   V_QTDEAFOL      FLOAT;  
BEGIN
   V_IDUTAPROVSOL := '';
   V_PRXSOLICMP   := '';
   V_CDFILCENT    := '';
   V_IDSOLIAPROV  := '';
   V_IDPERALTSAPR := '';
   SELECT NVL(MAX(FILIAL.CDFILCENTCMP), MAX(FILIAL.CDFILIAL)), NVL(MAX(CDMARCA), '')
     INTO V_CDFILCENTCMP, V_CDMARCA
     FROM FILIAL, PARASUPRI
   WHERE PARASUPRI.CDFILIAL = NVL(FILIAL.CDFILCENTCMP, FILIAL.CDFILIAL)
     AND FILIAL.CDFILIAL    = P_CDFILIOPELOG;
   SELECT MAX(IDUTAPROVSOL), MAX(SUBSTR(NVL(IDPERALTSAPR, W_N||W_N||W_N), 3, 1))
     INTO V_IDUTAPROVSOL, V_IDPERALTSAPR
     FROM PARCMPSUP
    WHERE CDFILIAL = P_CDFILIOPELOG;
   IF V_IDUTAPROVSOL = W_S THEN
      IF V_IDPERALTSAPR = W_S THEN
         V_IDSOLIAPROV := W_S;
      ELSE
         V_IDSOLIAPROV := W_N;
      END IF;
   ELSE
      V_IDSOLIAPROV := W_S;
   END IF;
   SELECT MAX(NVL(FILIAL.CDFILCENTCMP, FILIAL.CDFILIAL))
     INTO V_CDFILCENT
     FROM FILIAL
    WHERE FILIAL.CDFILIAL = P_CDFILIOPELOG;
   CALC_ESTOQ_SEGURA_OL(P_CDFILIOPELOG, P_CDPRODINIC, P_CDPRODFIN);
   FOR C_LOGCORTEOL IN(SELECT CDFILIALOL, DTINICIAL, DTFINAL, DTINICIALAF, DTFINALAF, CDREGIAO, CDMARCA, A.CDPRODUTO,
                              CDOPERADOR, QTESTOQ, QTPROGENTCONS, QTSOLIPROD, QTPROGENTAFOL, A.CDARVPROD,
                              DTPROGENTAF, CDFILDEST, NRAUTOFORN, QTPROGENTAF, QTACUMULADAF, DTLIMENTRAFOL, DTUTILIZA,
                              ROW_NUMBER() OVER (PARTITION BY A.CDARVPROD
                                                     ORDER BY CDOPERADOR, A.CDARVPROD, DTPROGENTAF, QTPROGENTAF, CDFILDEST, NRAUTOFORN) QTREGISTRO,
                              CDPRODARVOL, IDPARTCDMARCA,
                              ROW_NUMBER() OVER (PARTITION BY PRODUTO.CDPRODESTO
                                                     ORDER BY A.CDARVPROD, DTLIMENTRAFOL, DTPROGENTAF, QTACUMULADAF DESC) QTPRODUTO,
                              ROW_NUMBER() OVER (PARTITION BY A.CDARVPROD
                                                     ORDER BY CDOPERADOR, A.CDARVPROD) QTCDARVPROD,
                              QTPROGENTAFAUX                       
                         FROM TABLE(CALC_NECESSIDADE_OL(P_CDFILIOPELOG,
                                                        P_DTINICIAL, P_DTFINAL,
                                                        P_DTINICIALAF, P_DTFINALAF,
                                                        P_COMPRADOR,
                                                        P_CDREGIAO,
                                                        P_CDPRODINIC, P_CDPRODFIN,
                                                        P_TIPOCONSULTA,
                                                        'S')) A, PRODUTO
                        WHERE PRODUTO.CDPRODUTO = A.CDPRODUTO
                          --AND NVL(QTPROGENTAF, 0) > 0
                        ORDER BY A.CDARVPROD, DTLIMENTRAFOL, DTPROGENTAF, QTACUMULADAF DESC )
   LOOP
      V_QTPROGENTAF := C_LOGCORTEOL.QTPROGENTAF;
      IF V_CONTAITEMCORT = 0 THEN
         INSERT
           INTO LOGCORTEOL (CDFILIOPELOG, NRLOGCORTEOL, DTLOGCORTEOL, CDCOMPRADOR, CDOPERLANC,
                            CDFILCENT, DTINICIAL, DTFINAL, DTINICIALAF, DTFINALAF, LISTAREGIAO)
         VALUES (P_CDFILIOPELOG, P_NRLOGCORTEOL, TO_DATE(SYSDATE), C_LOGCORTEOL.CDOPERADOR, P_CDOPERLANC,
                V_CDFILCENTCMP, P_DTINICIAL, P_DTFINAL, P_DTINICIALAF, P_DTFINALAF, P_CDREGIAO);
         NOVO_CODIGO_NT('SOLICOMP'||P_CDFILIOPELOG||P_CDFILLANC, V_PRXSOLICMP);
         V_PRXSOLICMP := SUBSTR(V_PRXSOLICMP, 11, 10);
         INSERT
           INTO SOLICITA (CDFILSOLI, CDFILLANCA, NRSOLICMP, DTSOLCMP, IDTIPLAN,
                         CDFILCENT, CDOPERLANC, NRLOGCORTEOL)
         VALUES (P_CDFILIOPELOG, P_CDFILLANC, V_PRXSOLICMP, TO_DATE(SYSDATE), 'A',
                 V_CDFILCENT, P_CDOPERLANC, P_NRLOGCORTEOL);
      END IF;
      IF ((C_LOGCORTEOL.QTACUMULADAF < 0) AND (C_LOGCORTEOL.QTPROGENTAF > 0))THEN
         /*GRAVA O VALOR COM  O DESCONTO DO ESTOQUE PARA O PRIMEIRO RETIODTO*/
         IF C_LOGCORTEOL.QTCDARVPROD = 1 THEN
            V_QTPROGENTAF := ABS(C_LOGCORTEOL.QTACUMULADAF);
         END IF;
         V_QTESTOSEGU := 0;
         V_QTESTCALC  := 0;
         IF C_LOGCORTEOL.QTPRODUTO = 1 THEN
            BEGIN
               SELECT NVL(SUM(ESTOSEGU.QTESTOSEGU/PRODUTO.VRFATOCONV), 0)
                 INTO V_QTESTOSEGU
                 FROM ESTOSEGU, PRODUTO
                WHERE NVL(QTESTOSEGU, 0) > 0
                  AND ESTOSEGU.CDPRODESTO = PRODUTO.CDPRODESTO
                  AND PRODUTO.CDPRODUTO   =  C_LOGCORTEOL.CDPRODUTO
                  AND ESTOSEGU.CDFILIAL   = P_CDFILIOPELOG
               HAVING NVL(SUM(ESTOSEGU.QTESTOSEGU/PRODUTO.VRFATOCONV), 0) > NVL(C_LOGCORTEOL.QTESTOQ, 0);
            EXCEPTION
               WHEN OTHERS THEN BEGIN
                  V_QTESTOSEGU := 0;
               END;
            END;
            IF V_QTESTOSEGU > 0 THEN
               V_QTESTCALC := V_QTESTOSEGU - NVL(C_LOGCORTEOL.QTESTOQ, 0);
            END IF;
         END IF;
         IF C_LOGCORTEOL.IDPARTCDMARCA <> 'N' THEN
            SELECT NVL(MAX(NRSOLICMP), '&&&&&&&&&&')
              INTO V_PRXSOLICMP
              FROM SOLICITA
             WHERE NVL(NRLOGCORTEOL, 0) = TO_NUMBER(P_NRLOGCORTEOL)
               AND NVL(CDMARCA, 'N') = CASE C_LOGCORTEOL.IDPARTCDMARCA
                                          WHEN 'N'
                                          THEN 'N'
                                          ELSE C_LOGCORTEOL.CDMARCA
                                       END;
            /*INCLUI SOLICITAO COM MARCA CONSIDERANDO PARTICULARIDADE DA FILIAL*/
            IF V_PRXSOLICMP = '&&&&&&&&&&' THEN
               NOVO_CODIGO_NT('SOLICOMP'||P_CDFILIOPELOG||P_CDFILLANC, V_PRXSOLICMP);
               V_PRXSOLICMP := SUBSTR(V_PRXSOLICMP, 11, 10);
               INSERT
                INTO SOLICITA (CDFILSOLI, CDFILLANCA, NRSOLICMP, DTSOLCMP, IDTIPLAN,
                               CDFILCENT, CDOPERLANC, NRLOGCORTEOL, CDMARCA)
               VALUES (P_CDFILIOPELOG, P_CDFILLANC, V_PRXSOLICMP, TO_DATE(SYSDATE), 'A',
                       V_CDFILCENT, P_CDOPERLANC, P_NRLOGCORTEOL, CASE C_LOGCORTEOL.IDPARTCDMARCA
                                                                     WHEN 'N'
                                                                     THEN NULL
                                                                     ELSE C_LOGCORTEOL.CDMARCA
                                                                  END);
            END IF;
            /*NO INCLUI ITEM DE SOLICITAO PARA PRODUTO SEM RELACIONAMENTO DO OL*/
            IF C_LOGCORTEOL.CDPRODARVOL <> C_LOGCORTEOL.CDPRODUTO  THEN
               BEGIN
                  V_ITEMGERADO := 'S';
                  INSERT
                    INTO ITEMSOLI(CDFILSOLI, CDFILLAN, NRSOLICMP, CDPRODUTO,
                                  DTPROGENTR, QTSOLIPROD, IDSOLIAPROV, CDMARCA)
                  VALUES (C_LOGCORTEOL.CDFILIALOL, P_CDFILLANC, V_PRXSOLICMP, C_LOGCORTEOL.CDPRODUTO,
                          C_LOGCORTEOL.DTLIMENTRAFOL, V_QTPROGENTAF+V_QTESTCALC, 'S', CASE C_LOGCORTEOL.IDPARTCDMARCA
                                                                                         WHEN 'N'
                                                                                         THEN NULL
                                                                                         ELSE C_LOGCORTEOL.CDMARCA
                                                                                      END);
               EXCEPTION
                  WHEN OTHERS THEN BEGIN
                      V_ITEMGERADO := 'S';
                      UPDATE ITEMSOLI
                         SET QTSOLIPROD = QTSOLIPROD + V_QTPROGENTAF+V_QTESTCALC
                       WHERE ITEMSOLI.CDFILSOLI    = C_LOGCORTEOL.CDFILIALOL
                         AND ITEMSOLI.CDFILLAN     = P_CDFILLANC
                         AND ITEMSOLI.NRSOLICMP    = V_PRXSOLICMP
                         AND ITEMSOLI.CDPRODUTO    = C_LOGCORTEOL.CDPRODUTO
                         AND ITEMSOLI.DTPROGENTR   = C_LOGCORTEOL.DTLIMENTRAFOL
                         AND NVL(ITEMSOLI.CDMARCA, 'N')      = CASE C_LOGCORTEOL.IDPARTCDMARCA
                                                                  WHEN 'N'
                                                                  THEN 'N'
                                                                  ELSE C_LOGCORTEOL.CDMARCA
                                                               END;
                  END;
               END;
            END IF;
         ELSE
            SELECT NVL(MAX(NRSOLICMP), V_PRXSOLICMP)
              INTO V_PRXSOLICMP
              FROM SOLICITA
             WHERE NVL(NRLOGCORTEOL, 0) = TO_NUMBER(P_NRLOGCORTEOL)
               AND NVL(CDMARCA, 'N') = 'N';
            /*NO INCLUI ITEM DE SOLICITAO PARA PRODUTO SEM RELACIONAMENTO DO OL*/
            IF C_LOGCORTEOL.CDPRODARVOL <> C_LOGCORTEOL.CDPRODUTO  THEN
               BEGIN
                  V_ITEMGERADO := 'S';
                  INSERT
                    INTO ITEMSOLI(CDFILSOLI, CDFILLAN, NRSOLICMP, CDPRODUTO,
                                  DTPROGENTR, QTSOLIPROD, IDSOLIAPROV, CDMARCA)
                  VALUES (C_LOGCORTEOL.CDFILIALOL, P_CDFILLANC, V_PRXSOLICMP, C_LOGCORTEOL.CDPRODUTO,
                          C_LOGCORTEOL.DTLIMENTRAFOL, V_QTPROGENTAF+V_QTESTCALC, 'S', CASE C_LOGCORTEOL.IDPARTCDMARCA
                                                                                         WHEN 'N'
                                                                                         THEN NULL
                                                                                         ELSE C_LOGCORTEOL.CDMARCA
                                                                                      END);
               EXCEPTION
                  WHEN OTHERS THEN BEGIN
                      V_ITEMGERADO := 'S';
                      UPDATE ITEMSOLI
                         SET QTSOLIPROD = QTSOLIPROD + V_QTPROGENTAF+V_QTESTCALC
                       WHERE ITEMSOLI.CDFILSOLI    = C_LOGCORTEOL.CDFILIALOL
                         AND ITEMSOLI.CDFILLAN     = P_CDFILLANC
                         AND ITEMSOLI.NRSOLICMP    = V_PRXSOLICMP
                         AND ITEMSOLI.CDPRODUTO    = C_LOGCORTEOL.CDPRODUTO
                         AND ITEMSOLI.DTPROGENTR   = C_LOGCORTEOL.DTLIMENTRAFOL
                         AND NVL(ITEMSOLI.CDMARCA, 'N')      = CASE C_LOGCORTEOL.IDPARTCDMARCA
                                                                  WHEN 'N'
                                                                  THEN 'N'
                                                                  ELSE C_LOGCORTEOL.CDMARCA
                                                               END;
                  END;
               END;
            END IF;
         END IF;
      END IF;
      IF C_LOGCORTEOL.QTREGISTRO = 1 THEN
         IF ((C_LOGCORTEOL.QTACUMULADAF < 0) AND (C_LOGCORTEOL.QTPROGENTAF > 0))THEN
            V_IDCORTEOLCONS := 'S';
            V_IDCORTE       := 'S';
         ELSE
            V_IDCORTEOLCONS := 'N';
            V_IDSEMCORTE    := 'S';
         END IF;
         SELECT LPAD((TO_NUMBER(NVL(MAX(NRLOGCORTEOLCONS), 0))+1), 10, '0')
           INTO V_NRLOGCORTEOLCONS
           FROM LOGCORTEOLCONS;
         INSERT
           INTO LOGCORTEOLCONS (NRLOGCORTEOLCONS, CDFILIOPELOG, NRLOGCORTEOL, CDPRODARVOL,
                                QTESTOQ, QTPROGENTCONS,
                                QTSOLIPROD, QTPROGENTAFOL, QTPROGENTAF,
                                QTACUMULADAF,CDARVPROD, IDCORTEOLCONS)
         VALUES (V_NRLOGCORTEOLCONS,P_CDFILIOPELOG, P_NRLOGCORTEOL, C_LOGCORTEOL.CDPRODARVOL,
                 C_LOGCORTEOL.QTESTOQ, C_LOGCORTEOL.QTPROGENTCONS,
                 C_LOGCORTEOL.QTSOLIPROD, C_LOGCORTEOL.QTPROGENTAFOL, V_QTPROGENTAF,
                 C_LOGCORTEOL.QTACUMULADAF, C_LOGCORTEOL.CDARVPROD, V_IDCORTEOLCONS);
      END IF;
      --IF C_LOGCORTEOL.QTACUMULADAF < 0 THEN
      IF C_LOGCORTEOL.CDFILIALOL = C_LOGCORTEOL.CDFILDEST THEN
      SELECT NVL(SUM(ITEMAUTF.QTPROGENTAF-NVL(QTEFETENTRAF, 0)), 0)
        INTO V_QTDEAFOL
        FROM ITEMAUTF, AUTOFORNE
       WHERE ITEMAUTF.CDFILDEST               = AUTOFORNE.CDFILDEST
         AND ITEMAUTF.CDFILLANC               = AUTOFORNE.CDFILLANC
         AND ITEMAUTF.NRAUTOFORN              = AUTOFORNE.NRAUTOFORN
         AND ITEMAUTF.CDFILDEST               = C_LOGCORTEOL.CDFILIALOL
         AND ITEMAUTF.CDPRODUTO               = C_LOGCORTEOL.CDPRODUTO /*MEXER*/
         AND ITEMAUTF.DTPROGENTAF >=  TRUNC(SYSDATE)
         AND AUTOFORNE.CDOPERADOR             = P_COMPRADOR
         AND CASE AUTOFORNE.IDTIPOLANCAF
                WHEN 'M'
                THEN ITEMAUTF.DTPROGENTAF
                ELSE NVL(ITEMAUTF.DTENTRITMSOL, ITEMAUTF.DTPROGENTAF)
             END   = C_LOGCORTEOL.DTLIMENTRAFOL
         AND NVL(ITEMAUTF.IDBAIXITMAF, '1')   = '1'
         AND NVL(AUTOFORNE.IDBAIXAAF, '1')  NOT IN ('2', '3', '4', '5');
      END IF;
          SELECT LPAD((TO_NUMBER(NVL(MAX(NRLOGITEMCORTEOL), 0))+1), 10, '0')
            INTO V_NRLOGITEMCORTEOL
            FROM LOGITEMCORTEOL;
         INSERT
           INTO LOGITEMCORTEOL (NRLOGITEMCORTEOL, CDFILIOPELOG, NRLOGCORTEOL, CDFILDEST, NRAUTOFORN,
                                CDPRODUTO, CDMARCA,DTPROGENTAF, QTESTOQ,
                                QTPROGENTCONS, QTSOLIPROD, QTPROGENTAFOL, QTPROGENTAF,
                                QTACUMULADAF, DTLIMENTRAFOL, DTUTILIZA,CDARVPROD,
                                CDPRODARVOL, IDITEMGERADO, QTPROGENTAFAUX)
         VALUES (V_NRLOGITEMCORTEOL, P_CDFILIOPELOG, P_NRLOGCORTEOL, C_LOGCORTEOL.CDFILDEST, C_LOGCORTEOL.NRAUTOFORN,
                 C_LOGCORTEOL.CDPRODUTO, C_LOGCORTEOL.CDMARCA, C_LOGCORTEOL.DTPROGENTAF, C_LOGCORTEOL.QTESTOQ,
                 C_LOGCORTEOL.QTPROGENTCONS, C_LOGCORTEOL.QTSOLIPROD, C_LOGCORTEOL.QTPROGENTAFOL, CASE C_LOGCORTEOL.CDFILIALOL 
                                                                                                     WHEN C_LOGCORTEOL.CDFILDEST 
                                                                                                     THEN V_QTDEAFOL
                                                                                                     ELSE V_QTPROGENTAF
                                                                                                  END,
                 C_LOGCORTEOL.QTACUMULADAF, C_LOGCORTEOL.DTLIMENTRAFOL, C_LOGCORTEOL.DTUTILIZA, C_LOGCORTEOL.CDARVPROD,
                 C_LOGCORTEOL.CDPRODARVOL, V_ITEMGERADO, C_LOGCORTEOL.QTPROGENTAFAUX);
      --END IF;
      V_CONTAITEMCORT := V_CONTAITEMCORT + 1;
      V_ITEMGERADO    := 'N';
   END LOOP;
   P_ROWSAFFECT := P_NRLOGCORTEOL||V_IDCORTE||V_IDSEMCORTE;
END;
/

-- VERSAO --
BEGIN ATUVEROBJ('GERA_SOLICITA_CORTE_OL','5.33.XXX'); END;
/