CREATE OR REPLACE PROCEDURE ETIQUETA_EMBARQUE(P_CDFILIAL IN VARCHAR2,
                                             P_NREXPEDICAO IN VARCHAR2,
                                             P_TODOS IN VARCHAR2,
                                             P_DTINICIAL IN DATE,
                                             P_DTFINAL IN DATE)
IS
	V_YEAR VARCHAR2(4);
	V_INDEX NUMBER := 1;
	V_SEQ VARCHAR2(20);
   V_CDETIQUETA VARCHAR2(51);
   V_CONTADOR VARCHAR2(51);
   
	TYPE TYP_REGISTROS IS RECORD (CDFILIAL ETQEMBARQUE.CDFILIAL%TYPE, CDPRODUTO ETQEMBARQUE.CDPRODUTO%TYPE, 
								  NRLOTEESTQ ETQEMBARQUE.NRLOTEESTQ%TYPE, NRSUBLOTE ETQEMBARQUE.NRSUBLOTE%TYPE,
								  CDETIQUETA ETQEMBARQUE.CDETIQUETA%TYPE);
							  
	TYPE TYP_TABLE IS TABLE OF TYP_REGISTROS INDEX BY PLS_INTEGER;
	
	AR_RECORD TYP_TABLE;
   
	FUNCTION RETORNANOVOCODIGO(P_CONTADOR IN VARCHAR2) RETURN VARCHAR2
	AS
		V_SEQUENCIAL VARCHAR2(20);
	BEGIN
		NOVO_CODIGO_SC(P_CONTADOR, V_SEQUENCIAL);
		RETURN V_SEQUENCIAL;
	END;
   
BEGIN
	V_YEAR := SUBSTR(TO_CHAR(TRUNC(SYSDATE), 'YYYY'),3,2);
   
	FOR C_ETIQUETAS IN (SELECT CDFILIAL, CDPRODUTO, CDARVPROD, NMPRODUTO, NRLOTEESTQ, NRSUBLOTE,
							  CDPRODINTE, VRFATOCONVPR, QTITEMPROD, CDPRODESTO, COUNT(*) OVER() QTDREGISTROS
						  FROM (
								SELECT OP.CDFILIAL, OP.CDPRODUTO, PR.CDARVPROD, PR.NMPRODUTO, OP.NRLOTEESTQ, OP.NRSUBLOTE,
									   PR.CDPRODINTE, PR.VRFATOCONVPR,
									   SUM((OP.QTAPRODPREOP)-NVL(EE.QTETQLIVRE,0))QTITEMPROD, PR.CDPRODESTO
								  FROM PRODUTO PR, LOTE LT, ORDPRODUCAO OP,
										(SELECT COUNT(EE.CDETIQUETA)QTETQLIVRE, EE.CDPRODUTO, EE.NRLOTEESTQ, EE.NRSUBLOTE,EE.CDFILIAL
										   FROM ETQEMBARQUE EE
										  WHERE EE.IDVERIF = 'N'
									   GROUP BY EE.CDPRODUTO, EE.NRLOTEESTQ, EE.NRSUBLOTE, EE.CDFILIAL) EE
								 WHERE
								 (EE.CDFILIAL  (+)   = OP.CDFILIAL    ) AND
								 (EE.CDPRODUTO (+)   = OP.CDPRODUTO   ) AND
								 (EE.NRLOTEESTQ(+)   = OP.NRLOTEESTQ  ) AND
								 (EE.NRSUBLOTE (+)   = OP.NRSUBLOTE   ) AND
								
								 (LT.CDFILIAL     = OP.CDFILIAL    ) AND
								 (LT.NRLOTEESTQ   = OP.NRLOTEESTQ  ) AND
								 (LT.NRSUBLOTE    = OP.NRSUBLOTE   ) AND
								 (LT.CDPRODUTO    = OP.CDPRODUTO  )  AND
								
								 (OP.CDPRODUTO    = PR.CDPRODUTO   ) AND
								 (OP.IDSITORDPROD = '3') AND
								
								 ((INSTR(P_NREXPEDICAO, OP.NRORDPROD||'\'||OP.NRSUBORDPROD)<>0) OR (P_TODOS = 'T')) AND
								 (TRUNC(OP.DTHRFIMREAOP) BETWEEN P_DTINICIAL AND P_DTFINAL)  AND
								 (OP.CDFILIAL = P_CDFILIAL)
								
								GROUP BY OP.CDFILIAL, OP.CDPRODUTO, PR.CDARVPROD, PR.NMPRODUTO, OP.NRLOTEESTQ, 
										 OP.NRSUBLOTE, PR.CDPRODINTE, PR.VRFATOCONVPR, PR.CDPRODESTO
								)
						WHERE QTITEMPROD > 0 ) LOOP

		FOR I IN 1..C_ETIQUETAS.QTITEMPROD LOOP

			AR_RECORD(V_INDEX).CDFILIAL   := C_ETIQUETAS.CDFILIAL; 
			AR_RECORD(V_INDEX).CDPRODUTO  := C_ETIQUETAS.CDPRODUTO;
			AR_RECORD(V_INDEX).NRLOTEESTQ := C_ETIQUETAS.NRLOTEESTQ;
			AR_RECORD(V_INDEX).NRSUBLOTE  := C_ETIQUETAS.NRSUBLOTE;
			
         V_CONTADOR   := C_ETIQUETAS.CDPRODINTE || V_YEAR || C_ETIQUETAS.NRLOTEESTQ;
			V_SEQ        := RETORNANOVOCODIGO(V_CONTADOR);
			V_CDETIQUETA := V_CONTADOR || SUBSTR(V_SEQ, LENGTH(V_SEQ)-8, 9);
			
			AR_RECORD(V_INDEX).CDETIQUETA := V_CDETIQUETA;
			V_INDEX := V_INDEX + 1;		

			IF (MOD(V_INDEX, 100) = 0) THEN  
            FORALL J IN AR_RECORD.FIRST .. AR_RECORD.LAST

            INSERT INTO ETQEMBARQUE (CDFILIAL,CDPRODUTO, NRLOTEESTQ, NRSUBLOTE,CDETIQUETA, IDDESBLOQUEADA,IDVERIF, QTITEMETIQ)
            VALUES (AR_RECORD(J).CDFILIAL, AR_RECORD(J).CDPRODUTO, NVL(AR_RECORD(J).NRLOTEESTQ,' '), NVL(AR_RECORD(J).NRSUBLOTE,' '), 
                  AR_RECORD(J).CDETIQUETA, 'N', 'N', 1);

            AR_RECORD.DELETE;  
            V_INDEX := 1;
			END IF;
		END LOOP;
      
      IF AR_RECORD.FIRST IS NOT NULL THEN
         FORALL J IN AR_RECORD.FIRST .. AR_RECORD.LAST  
         
         INSERT INTO ETQEMBARQUE (CDFILIAL,CDPRODUTO, NRLOTEESTQ, NRSUBLOTE,CDETIQUETA, IDDESBLOQUEADA,IDVERIF, QTITEMETIQ)
         VALUES (AR_RECORD(J).CDFILIAL, AR_RECORD(J).CDPRODUTO, NVL(AR_RECORD(J).NRLOTEESTQ,' '), NVL(AR_RECORD(J).NRSUBLOTE,' '), 
               AR_RECORD(J).CDETIQUETA, 'N', 'N', 1);
      END IF;
      V_INDEX := 1;
      
	END LOOP;
END;
/