function Cus01800_ProdutosNaoEstocaveis_Controller(ZhFilterPreferences, ZhPreferences, Query, ScreenService, ZHPromise, General, templateManager, ZhUtil, ZhKeyboardService) {
    
    var self = this;
    this.initFilter = function(args) {
        let widget = args.owner;
        let row = {
            CDFILIAL: getLocalVar('CDFILIAL'),
            NMFILIAL: getLocalVar('CDFILIAL') + " | " + getLocalVar('NMFILIAL')
        };
        self.startFilter(widget, row);
    };

    this.startFilter = function (widget, currentRow) {
        return ZhPreferences.getDefaultWidgetPreferences(widget.id).then(function (result) {
            if (result && result.DEFAULT_FILTER) {
                ZhPreferences.getPreferences('filter', Query.build().where('WIDGET_ID').equals(widget.id)).then(function (filters) {
                    var defaultFilter = filters.filter(function (filter) {
                        return filter.ID == result.DEFAULT_FILTER;
                    })[0];
                    var filter = {
                        ID: defaultFilter.LABEL_TO_PREFERENCE || 'EDITED',
                        FILTER_ROW: JSON.parse(defaultFilter.FILTER_ROW)
                    };
                    currentRow = filter.FILTER_ROW;
                    ZhFilterPreferences.applyFilter(widget, filter).then(function () {
                        widget.appliedFilter = widget.appliedFilter || filter;
                        widget.appliedFilter.ID = result.DEFAULT_FILTER;
                        if (defaultFilter.LABEL_TO_PREFERENCE) {
                            widget._filterInfo[0].value = defaultFilter.LABEL_TO_PREFERENCE;
                        }
                    });
                });
            } else {
                if (Util.isUndefinedOrNull(currentRow) || Util.isEmptyObject(currentRow)) {
                    currentRow = buildFilterCurrentRow(widget);
                }
            }
            return ZhFilterPreferences.openFilterWidget(widget, currentRow);
        });
    };

    this.afterFilter = function(args){
        let widget = args.owner;
        let stripeWidget = widget.container.getWidget('stripeProdutos');
        let filterRow = args.e.preference.FILTER_ROW;
        stripeWidget.currentRow = angular.copy(filterRow);
    };
    
    this.saveInlineEdit = function(widget) {
        var naoEstocaveis = widget.dataSource.data.filter(a=>a.hasOwnProperty('changed_IDCNTRESTOQ')).filter(b=>b.IDCNTRESTOQ == 'N');
        
        if(naoEstocaveis.length > 0){
            ScreenService.confirmMessage('A confirmação provocará a exclusão da posição de estoque de alguns itens. Confirma operação?', 'question',
                function(success) {
                    widget.dataSource.save().then(function(callback){
                        General.callRestEngine('cus_parametros#/ProdutosNaoEstocaveis/deletePosEst', "DataSet", naoEstocaveis).then(function(){
                            ScreenService.notificationMessage("Registro atualizado com sucesso!", "success"); 
                            widget.commitInlineEdit();
                        });
                    });
                }
            );
        } else {
            widget.dataSource.save().then(function(){
                ScreenService.notificationMessage("Registro atualizado com sucesso!", "success"); 
                widget.commitInlineEdit();
            });
        }
    };

    this.setChanged = function( args ){
        const row = args.row;
        const currentWidget = args.owner.field.widget;
        const nameWidget = 'gridProdutosNaoEstocaveis';
        const nameField = 'IDCNTRESTOQ';
        
        let widget = templateManager.container.getWidget(nameWidget);
        if( currentWidget.name !== nameWidget || widget.inEditMode() ) return;
        
        
        row.changed = true;
        if(!row.hasOwnProperty('changed_'+nameField)){
            row['changed_'+nameField] = row[nameField] === 'S' ? 'N' : 'S';
        }
        if(!widget) return;
        widget.inlineEditing = true;
        if(!widget.inInlineEditMode())
            widget.inlineEdit();
        if(!widget.lastInlineEditingElement)
            widget.lastInlineEditingElement = $();
       
    };

    this.saveCadastroAutomatico = function(widget){
        if(widget.isValid()){
            if(General.comparaPratoProduto(widget.currentRow.CDARVPRODINI, widget.currentRow.CDARVPRODFIN, getLocalVar('CDPICTPROD'))){
                var stripe = templateManager.container.getWidget('stripeProdutos');
                widget.currentRow.CDFILIAL = stripe.currentRow.CDFILIAL;
            
                if(widget.currentRow.NAOESTOCAVEL == 'N'){
                    ScreenService.confirmMessage('A confirmação provocará a exclusão da posição de estoque de alguns itens. Confirma operação?', 'question',
                        function(success) {
                        self.callSaveAutomatico(widget);
                        }
                    );
                }else self.callSaveAutomatico(widget); 
            }else ScreenService.showMessage('O produto final deve ser maior que o produto inicial!');
        }
    };

    this.callSaveAutomatico = function(widget){
        General.callRestEngine('cus_parametros#/ProdutosNaoEstocaveis/automaticoEstocavel', "Row", widget.currentRow).then(function() {
            ScreenService.closePopup(true);
            templateManager.container.getWidget('gridProdutosNaoEstocaveis').reload();
            ScreenService.notificationMessage("Cadastro automático efetuado com sucesso!", "success");
        });
    };

    this.openCadAutomatico = function(widget){
        ScreenService.openPopup(templateManager.container.getWidget('filterCadastroAutomatico'));
    };

    this.setFilterReport = function(args){
        var stripe = templateManager.container.getWidget('stripeProdutos');
        var header = [
            {
                "label": 'Unidade', 
                "value": stripe.currentRow.NMFILIAL
            }
        ];
        
        args.e.metadata.filter = header;
        args.e.metadata.columns.IDCNTRESTOQREL = args.e.metadata.columns.IDCNTRESTOQ;
        delete args.e.metadata.columns.IDCNTRESTOQ;
    };

    this.clearFields = function(widget){
        widget.fields.forEach(field =>{
            field.setValue('');
        });
    };
}

Configuration(function (ContextRegister) {
	ContextRegister.register('Cus01800_ProdutosNaoEstocaveis_Controller', Cus01800_ProdutosNaoEstocaveis_Controller);
});